
#define FallOffDistance 20
#define WIDTH (256+128+32)

#define num_vertex 512
point_t vertex[300];
class SortVoxel {
	public:
		ListIndex_t I;
		BYTE Z;
		SortVoxel() : I(0), Z(0) {};
		SortVoxel(ListIndex_t i, BYTE z) : I(i), Z(z) {};
		inline boolean operator >(SortVoxel VL2){ return (Z>VL2.Z ? TRUE : FALSE ); }
};
class Voxel2D {   //Storage for semi-processed voxels
	public:
		point2D_t P;
		FP_type z;
		int W;
		BYTE col;
	public:
		Voxel2D() : P(0,0), W(0){};
		Voxel2D(point2D_t p, int w) : P(p), W(w){};
		Voxel2D(point2D_t p, int w, FP_type Z, BYTE c): P(p), W(w), z(Z), col(c){};
};

//Main loop
void OrganicVoxel_X(){
	pMatrix_t ObjMatrix;
	for(int i=0;i<64;i++){
	 x_set_rgb(i+64, i>>2, i,i>>2);
	}
	char ch=0; point2D_t p;
	VertexList VL(num_vertex);
	SimpleList<Voxel2D> V2DL(num_vertex);
	SortableList<SortVoxel> SVL(num_vertex);
	point_t	 P(-5,-5,50), ObjPos(0,0,FallOffDistance*15);
	rotation3D_t ObjRot(0,0,0);
	int width;

	vertex[0]=point_t(-1.5,-1.5,0);
	VL.EmptyList();
	VL.Add(vertex[0]);
	int r=0;
	for(i=1;i<num_vertex;i++){
		point_t p; 		r=(++r)%16; //r = random(6);
		VL.ResetEnd();  		p = VL.Current();//ex[i-1];
		switch (r>>2) {
			case 0 : p=p+point_t( 1, 0, 0); break;
			case 1 : p=p+point_t( 0, 1, 0); break;
			case 2 : p=p+point_t(-1, 0, 0); break;
			case 3 : p=p+point_t( 0,-1, 0); break;
			case 4 : p=p+point_t( 0, 0, 1); break;
			case 5 : p=p+point_t( 0, 0,-1); break;
		}
		VL.Add( (p+point_t(0,0,0.525)) );
	}

	VL.EmptyList();        //Malcolm's fractal
	VL.Add(point_t(0,0,0));
	VL.Add(point_t(1,0,0));
	for(i=0;i<9;i++){
				ObjMatrix.SetToRotatedAxes(rotation3D_t(0,0,1024));
					VL.ResetEnd(); P=VL.Current();
					do{
						VL.Add( ObjMatrix.UsedOn( VL.Current()-P) + P);
					}while(--VL);
	}

	VL.ResetStart(); i=0;
	point_t mid(0,0,0);
	do{
		VL.Current()=VL.Current()+point_t(0,0,0.025)*i++;
		//mid=mid+VL.Current();
	}while(++VL);
	//mid=(mid*FP_type(1000/i))*0.001;
	mid=VL[i/2];
	VL.ResetStart();
	do{	VL.Current()=VL.Current()-mid; }while(++VL);

	VL.ResetStart();
	SVL.EmptyList();
	i=0;
	do{	SVL.Add(SortVoxel(i,0)); i++; }while(++VL);

	do{
		FP_type z, Shade;
		ch=0;   ListIndex_t ind=0;
		x_rect_fill(0,0,ScrnPhysicalPixelWidth, ScrnPhysicalHeight,
								LogicalScr,0);
		ObjMatrix.SetToRotatedAxes(ObjRot);

		/*VL.ResetStart();
		SVL.EmptyList();
		do{
			P=ObjMatrix.UsedOn(VL.Current());
			P=P+ObjPos;
			z=P*vector3D(0,0,1);
			SVL.Add(DepthSortIndex(VL.IndexOfCurrent(), z) );
			//SVL[ind].I=ind;
			//++SVL;
			//ind++;
			SVL.SortQ();
		}while(++VL);
		/*/
		SVL.ResetStart();   //Ready to traverse vertex list  //Prepare loop
		//VL.ResetStart();
		//ListIndex_t ind=0;
		do{
			//DepthSortIndex& DSI =SVL.Current();
			SortVoxel& DSI =SVL.Current();
			Voxel2D& Vox = V2DL[ind];
			ind=SVL.Current().I; //SVL.Current().I;
			P=ObjMatrix.UsedOn(VL[ind]);
			P=P+ObjPos;
			z=P*vector3D(0,0,1);
			p=P.ProjectTo2D();
			p=p+point2D_t(ScrnPhysicalPixelWidth>>1,
											ScrnPhysicalHeight>>1);
			if(z>FallOffDistance) Shade = FallOffDistance/z;
			V2DL[ind]=Voxel2D(p, WIDTH/z, z, Shade*63+64);
			/*V2DL[ind].W =  WIDTH/z;
			V2DL[ind].col = (z>0 ? Shade*63+64 : 0);
			V2DL[ind].P=p;
			V2DL[ind].z=z;  */
			SVL.Current().Z=-V2DL[ind].col; //z

			//SVL[ind].I=ind;
			//++SVL;
			//ind++;

		}while(++SVL); /**/
		SVL.SortQ();  //Slow
		Sky->Draw(LogicalScr);
		SVL.ResetStart();   //Ready to traverse vertex list //DrawLoop
		do{
			Voxel2D& v=V2DL[SVL.Current().I];
			if(/* (z)>1*/v.col ){
					p=v.P;
					width=v.W;
					if( (unsigned int) p.V(0)<ScrnPhysicalPixelWidth
								 && (unsigned int) p.V(1)<ScrnPhysicalHeight)
					if(!width){
							x_put_pix(p.V(0),p.V(1),LogicalScr, v.col);
					}
					else

						x_rect_fill_clipped(p.V(0)-(width>>1),p.V(1)-(width>>1),
																p.V(0)-(width>>1)+width,p.V(1)-(width>>1)+width,
																//p.V(0)+width,p.V(1)+width,
																LogicalScr, v.col); /**/


			}
		}while(++SVL);
		x_wait_vsync();
		PageFlip();
		ObjPos=ObjPos-point_t(0,0,0.02)*(ObjPos*vector3D(0,0,1)-50);
		if(kbhit()){
			ch=getch();
			switch (ch) {
			case '8': ObjRot.Rotate(0,20); break;
			case '2': ObjRot.Rotate(0,-20);break;
			case '4': ObjRot.Rotate(1,20);break;
			case '6': ObjRot.Rotate(1,-20);break;
			case '7': ObjRot.Rotate(2,20); break;
			case '9': ObjRot.Rotate(2,-20); break;
			case '+': ObjPos=ObjPos+point_t(0,0,10);  break;
			case '-': ObjPos=ObjPos+point_t(0,0,-10);  break;
			case ' ': ObjPos=point_t(0,0,FallOffDistance*32);
				break;
			}
		}
		ObjRot.Rotate(2,2);
		ObjRot.Rotate(1,1);
		ObjRot.Rotate(0,1);
	}while(ch!=27);
}




/*
void OldOrganicVoxel_X(){
	pMatrix_t ObjMatrix;
	for(int i=0;i<64;i++){
	 x_set_rgb(i,i,i,i); //White
	 x_set_rgb(i+64, i>>2, i,i>>2);
	}
	char ch=0; point2D_t p;
	VertexList VL(num_vertex);
	//SortableList<SortVL> SVL(num_vertex);
	DepthSortIndexList SVL(num_vertex);
	point_t	 P(-5,-5,50), ObjPos(0,0,FallOffDistance*63);
	rotation3D_t ObjRot(0,0,0);


	vertex[0]=point_t(-1.5,-1.5,0);
	VL.EmptyList();
	VL.Add(vertex[0]);
	int r=0;
	for(i=1;i<num_vertex;i++){
		point_t p; 		r=(++r)%16; //r = random(6);
		VL.ResetEnd();  		p = VL.Current();//ex[i-1];
		switch (r>>2) {
			case 0 : p=p+point_t( 1, 0, 0); break;
			case 1 : p=p+point_t( 0, 1, 0); break;
			case 2 : p=p+point_t(-1, 0, 0); break;
			case 3 : p=p+point_t( 0,-1, 0); break;
			case 4 : p=p+point_t( 0, 0, 1); break;
			case 5 : p=p+point_t( 0, 0,-1); break;
		}
		VL.Add( (p+point_t(0,0,0.525)) );
	}

	VL.EmptyList();        //Malcolm's fractal
	VL.Add(point_t(0,0,0));
	VL.Add(point_t(1,0,0));
	//VL.Add(point_t(1,1,0));
	for(i=0;i<9;i++){
				ObjMatrix.SetToRotatedAxes(rotation3D_t(0,0,1024));

					VL.ResetEnd(); P=VL.Current();
					do{
						VL.Add( ObjMatrix.UsedOn( VL.Current()-P) + P);

					}while(--VL);
	}

	VL.ResetStart(); i=0;
	point_t mid(0,0,0);
	do{
		VL.Current()=VL.Current()+point_t(0,0,0.025)*i++;
		//mid=mid+VL.Current();
	}while(++VL);
	//mid=(mid*FP_type(1000/i))*0.001;
	mid=VL[i/2];
	VL.ResetStart();
	do{	VL.Current()=VL.Current()-mid; }while(++VL);

	VL.ResetStart();
	SVL.EmptyList();
	i=0;
	do{	SVL.Add(DepthSortIndex(i,0)); i++; }while(++VL);

	do{
		FP_type z;
		ch=0;
		x_rect_fill(0,0,ScrnPhysicalPixelWidth, ScrnPhysicalHeight,
								LogicalScr,0);
		ObjMatrix.SetToRotatedAxes(ObjRot);
		//ObjMatrix=pMatrix_t(point_t(1,0,0), point_t(0,1,0), point_t(0,0,1));

		SVL.ResetStart();   //Ready to traverse vertex list  //Prepare loop
		//VL.ResetStart();
		//ListIndex_t ind=0;
		do{
			P=ObjMatrix.UsedOn(VL[SVL.Current().I]);
			P=P+ObjPos;
			z=P*vector3D(0,0,1);
			SVL.Current().Z=z;
			//SVL[ind].I=ind;
			//++SVL;
			//ind++;
		}while(++SVL);

		SVL.SortQ();  //Slow
		Sky->DrawX(LogicalScr);
		SVL.ResetStart();   //Ready to traverse vertex list //DrawLoop
		do{
			P=ObjMatrix.UsedOn(VL[SVL.Current().I]);
			P=P+ObjPos;
			z=SVL.Current().Z;
			int width;
			if( (z)>1){
				FP_type Shade=1;
				p=P.ProjectTo2D();      //Not complete projection
				p=p+point2D_t(ScrnPhysicalPixelWidth>>1,
											ScrnPhysicalHeight>>1); //Move to screen center


					if(z>FallOffDistance) Shade = FallOffDistance/z;
					width = WIDTH/z;
					if( (unsigned int) p.V(0)<ScrnPhysicalPixelWidth
								 && (unsigned int) p.V(1)<ScrnPhysicalHeight)
					if(!width){

							x_put_pix(p.V(0),p.V(1),LogicalScr,char (64+63*Shade));
					}
					else

						x_rect_fill_clipped(p.V(0)-(width>>1),p.V(1)-(width>>1),
																p.V(0)-(width>>1)+width,p.V(1)-(width>>1)+width,
																//p.V(0)+width,p.V(1)+width,
																LogicalScr, 64+63*Shade);

				//vertex[i]=vertex[i]-point_t(0,0,1);
			}
			//x_triangle(-10,0,359,0,50,240,0,PageScr[0]);
		}while(++SVL);
		x_wait_vsync();
		PageFlip();
		ObjPos=ObjPos-point_t(0,0,0.02)*(ObjPos*vector3D(0,0,1)-50);
		if(kbhit()){
			ch=getch();
			switch (ch) {
			case '8': ObjRot.Rotate(0,20); break;
			case '2': ObjRot.Rotate(0,-20);break;
			case '4': ObjRot.Rotate(1,20);break;
			case '6': ObjRot.Rotate(1,-20);break;
			case '7': ObjRot.Rotate(2,20); break;
			case '9': ObjRot.Rotate(2,-20); break;
			case '+': ObjPos=ObjPos+point_t(0,0,10);  break;
			case '-': ObjPos=ObjPos+point_t(0,0,-10);  break;
			case ' ': ObjPos=point_t(0,0,FallOffDistance*63);
				break;
			}
		}
		ObjRot.Rotate(2,5);
		ObjRot.Rotate(1,1);
		ObjRot.Rotate(0,1);
		//ObjPos=ObjPos-point_t(0,0,1);

	}while(ch!=27);
}/**/

