// STARS.CPP - Part of DEMO

#include "3dmath.hpp"
#include "lists.hpp"
#include "stdlib.h"

class StarField_t;
class Star_t : public point_t {
	public:
		Star_t() : point_t(){};
		Star_t(vector3D v) : point_t(v){};
		Star_t(FP_type v0, FP_type v1, FP_type v2) : point_t(v0,v1,v2){};

		friend class StarField_t;
};

Star_t RandomStar(LONGWORD d){
	return Star_t(random(50)-25,random(50)-25,random(500)-250);
}

class StarField_t : public SimpleList<Star_t> {
	protected:
		BYTE LowCol,ColRange;
		FP_type FallOffDist;
		rotation3D_t Direction;
	public:
		point_t Movement;
		rotation3D_t Rotation;
		StarField_t(ListIndex_t,FP_type, BYTE, BYTE);
		virtual Draw(WORD);
		DrawModeX(WORD);

};
StarField_t::StarField_t(ListIndex_t n, FP_type fod, BYTE l, BYTE r) :
				SimpleList<Star_t>(n), LowCol(l), ColRange(r), Movement(0,0,0),
				FallOffDist(fod) {
	FP_type d = FallOffDist*ColRange;
	Star_t star;
	for(int i=0;i<n;i++)
	{ //star.Random(d);
		Add( RandomStar(d) );//Star_t(random(d*2)-d,random(d*2)-d,random(d*2)-d));
	}
}

StarField_t::DrawModeX(WORD where){
	point2D_t p;
	Star_t P;
	FP_type Shade;
	pMatrix_t mat;
	ResetStart();
	Direction.Add(Rotation);
	mat.SetToRotatedAxes(Direction);
	do{

		Current()=Current()-Movement;
		//P=mat.UsedOn(Current());
		if( P.v[2]>0){
			p=P.ProjectTo2D();
			p=p+point2D_t(ScrnPhysicalPixelWidth>>1,
											ScrnPhysicalHeight>>1); //Move to screen center
			Shade=1; if(P.v[2]>FallOffDist) Shade = FallOffDist/P.v[2];
			if( (unsigned int) p.V(0)<ScrnPhysicalPixelWidth
								 && (unsigned int) p.V(1)<ScrnPhysicalHeight )
				x_put_pix(p.V(0), p.V(1), where, LowCol+Shade*ColRange);

		}
		else
		{
			Current()=RandomStar(FallOffDist*ColRange);
		}
	}while(++*this);
}

StarField_t::Draw(WORD where){
	if(DemoGraphicMode==DGM_ModeX) return DrawModeX(where);
}


StarField_t *Sky;
